local coaf = require "coaf.core"
local _dbg = require "coaf.debug"
local run_daemon = require "coaf.run_daemon"

local AVAHI = {

}

local function check_avahi_user()
    local create = true
    for line in io.lines("/etc/passwd") do
        if line:match("^avahi") then
            create = nil
            break
        end
    end

    if create then
        os.execute("adduser -s /bin/false -D avahi")
    end
end

function AVAHI.start()
    local config = _G.hostapm.localLink
    
    AVAHI.stop()

    local args = {}
    -- if config.enable == "true" then
        table.insert(args, "-B")
        table.insert(args, config.ip)
    -- end

    AVAHI.avahi_daemon_task = run_daemon.Create({
        name = "avahi-daemon",
        run = "/usr/sbin/avahi-daemon",
        args = args,
        on_terminate = "restart",
    })

    if AVAHI.avahi_daemon_task then
        AVAHI.avahi_daemon_task:Start()
    end
end

function AVAHI.Init()
    check_avahi_user()
end

function AVAHI.stop()
    if AVAHI.avahi_daemon_task then
        AVAHI.avahi_daemon_task:Kill()
        AVAHI.avahi_daemon_task:Destroy()
        AVAHI.avahi_daemon_task = nil
    end
end

return AVAHI