require "kiloview.configure_helper"
----------------------------
_G.PTZ_CONFIG_LOADING = false
----------------------------
local function INDEXOF(a,b)
	local r = {}
	local i
	for i=a,b do
		table.insert(r,i)
	end
	return r
end


local function OnDeviceChanged(obj)
	local ptz_mod = require "ptzModule"
	ptz_mod.Config()
end

local function OnOptionsChanged(obj)
	local ptz_mod = require "ptzModule"
	ptz_mod.Config()
end

local function OnSocketChanged(obj)
	local ptz_mod = require "ptzModule"
	ptz_mod.UpdateSocketService( obj.enable, obj.port )
end

PTZ_Template = OBJECT({
	device = OBJECT({
		device = { type="string", value="null" },
		baudrate = { type="integer", value=9600 },
		databits = { type="integer", value=8 },
		parity = { type="string", value="none" },
		stopbits = { type="integer", value=1 },
		xonxoff = { type="integer", value=0 },
		rtscts = { type="integer", value=0 }
	}, OnDeviceChanged),

	socket_svc = OBJECT({
		enable = { type="integer", value=1 },
		port = { type="integer", value=10232 }
	}, OnSocketChanged ),

	options = OBJECT({
		address = { type="integer", value=1 },
		protocol = { type="string", value="null" },
		pan_speed = { type="number", value=0.5 },
		tilt_speed = { type="number", value=0.5 },
		zoom_speed = { type="number", value=0.5 },
		focus_speed = { type="number", value=0.5 },
		iris_speed = { type="number", value=0.5 }
	}, OnOptionsChanged),

	presets = ARRAY(
		INDEXOF(0,99),

		OBJECT({
			token = { type="string", value="" },
			name = { type="string", value="" }
		})
	)
})



