local busOprs = require "busOprs"
local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local function CheckOption(opt)
	local k,v
	k,v = opt:match( "(name):(.+)" )
	if k and v then
		return k,v
	end
	
	k,v = opt:match( "/(name)/(.+)" )
	if k and v then
		return k,v
	end
	
	k,v = opt:match( "(location):(.+)" )
	if k and v then
		return k,v
	end
	
	k,v = opt:match( "/(location)/(.+)" )
	if k and v then
		return k,v
	end
	
	k,v = opt:match( "(hardware):(.+)" )
	if k and v then
		return k,v
	end
	
	k,v = opt:match( "/(hardware)/(.+)" )
	if k and v then
		return k,v
	end
	
	return nil, nil
end


if type(request.Scopes) == "table" then
	local i
	local sets = {}
	local sets_cc = 0
	for i=1, #request.Scopes do
		local k, v = CheckOption( request.Scopes[i] )
		if k and v then
			if k == "name" then
				sets["onvif.deviceName"] = v
				sets_cc = sets_cc + 1
			elseif k == "location" then
				sets["onvif.location"] = v
				sets_cc = sets_cc + 1
			elseif k == "hardware" then
				sets["onvif.deviceType"] = v
				sets_cc = sets_cc + 1
			end
		end
	end
	if sets_cc > 0 then
		busOprs.Set( sets )
	end	
end

return SVC_OK

