local busOpr = require "busOprs"
local timedatectl = require "kiloview.systemd-timedate"

local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

if request.DateTimeType == tt__SetDateTimeType__NTP then
	timedatectl.SetNTP( "true" )	--No address so only start NTP service.
else
	--TODO: Now ignored timezone settting.
	local timeinfo = timedatectl.GetTimeDateInfo()
	
	if request.UTCDateTime and request.UTCDateTime.Date and request.UTCDateTime.Time then
		local timeStr = request.UTCDateTime.Date.Year .. "-" .. 
						request.UTCDateTime.Date.Month .. "-" ..
						request.UTCDateTime.Date.Day .. " " ..
						request.UTCDateTime.Time.Hour .. ":" ..
						request.UTCDateTime.Time.Minute .. ":" ..
						request.UTCDateTime.Time.Second
						
		timedatectl.SetNTP( "false" )
		timedatectl.SetTimezone( "UTC" )
		timedatectl.SetTime( timeStr ) --Change time by UTC time.
		timedatectl.SetTimezone( timeinfo["zone"] )	--Set it back.
	end
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	DateTimeType: (!)
	(
		tt__SetDateTimeType__Manual: 0,
		tt__SetDateTimeType__NTP: 1,
	)
	DaylightSavings: (!)
	(
		xsd__boolean__false_: 0,
		xsd__boolean__true_: 1,
	)
	TimeZone: 
	{
		TZ: <char*> (!)
	}
	UTCDateTime: 
	{
		Time: (!)
		{
			Hour: <int> (!)
			Minute: <int> (!)
			Second: <int> (!)
		}
		Date: (!)
		{
			Year: <int> (!)
			Month: <int> (!)
			Day: <int> (!)
		}
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]


