local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local reset = require "kiloview.reset"
require "features"

if request.FactoryDefault == tt__FactoryDefaultType__Soft then
	--Software reset, so reset the parameters but no network addresses changing.
	os.execute( "/bin/rm -Rf /data/configs/*.conf" )
	_G.REBOOT_REQUIRE = true
else
	local r, m = pcall( require, "kiloview." .. _G.DEVICE_TYPE .. ".restoreFactory" )
	if r and m then
		m.RestoreFactory()
		_G.REBOOT_REQUIRE = true
	else
		print( "***WARNING: No corresponding device type restore module found!", m )
	end
end

return {}

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

