local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local preset = {}
local i
local name

for i=0,99 do
	if _G.ptz.presets[i].token ~= "" then
		name = _G.ptz.presets[i].name
		if name == "" then
			name = string.format( "Preset%03d", i )
		end
		table.insert( preset, { Name = name, token = _G.ptz.presets[i].token } )
	end
end

return { Preset = preset }


--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
	__sizePreset: <int>
	Preset[...]: 
	{
		Name: <char*>
		PTZPosition: 
		{
			PanTilt: 
			{
				x: <float> (!)
				y: <float> (!)
				space: <char*>
			}
			Zoom: 
			{
				x: <float> (!)
				space: <char*>
			}
		}
		token: <char*>
		__anyAttribute: <_XML>
	}
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

