local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

local ptz_m = require "ptzModule"
if not ptz_m or not ptz_m.ptz_obj then
	return SVC_OK
end

--print( "PTZ: GotoPreset: token=", request.PresetToken )
if request.PresetToken then
	local i, tok
	for i=0,99 do
		if _G.ptz.presets[i].token == request.PresetToken then
			tok = i
			break
		end
	end

	if not tok then
		tok = tonumber( request.PresetToken:match("[0-9]+") )
	end

	if tok then
		ptz_m.ptz_obj:LoadPreset(tok)
	end
end

return SVC_OK

--[==[ *ABSTRACT* The 'request' arguments:
{
	ProfileToken: <char*> (!)
	PresetToken: <char*> (!)
	Speed: 
	{
		PanTilt: 
		{
			x: <float> (!)
			y: <float> (!)
			space: <char*>
		}
		Zoom: 
		{
			x: <float> (!)
			space: <char*>
		}
	}
}
]==]

--[==[ *ABSTRACT* The 'response' arguments:
{
}
]==]

--NOTE: SVC_OK = 0, SVC_NOIMPL = 1

