local args = {...}
local request = args[1]
if not request then
	error( "Invalid request argument passed!" )
end

--[==[ *ABSTRACT* The 'request' arguments:
{
	Types: <_QName>
	Scopes: 
	{
		__item: <char*>
		MatchBy: <char*>
	}
}
]==]

if _G.onvif.control.enabled == 1 and _G.onvif.discoverable == 1 then	--Only send response if discoverable
	local response = {
		ProbeMatch = {
			wsa__EndpointReference = {
				Address = GLOBAL_INFO.HARDWARE_ID
			},
			Types = GLOBAL_INFO.GetEndpointTypes(),
			Scopes = {
				{ __item = GLOBAL_INFO.GetEndpointScopes() },
			},
	
			XAddrs = GLOBAL_INFO.GetServiceAddress(),
			MetadataVersion = 1
		}
	}

	--NOTE: Probe need we send ProbeMatches ourself.
	OnvifSvc.Discovery.SendProbeMatches(response)
--else
--	print( "***NOTE: The ONVIF Service is set Non-discoverable while someone probing it." )
end

return SVC_OK
-- SVC_OK = 0, SVC_NOIMPL = 1

