require "kiloview.configure_helper"

---------
local function getSampling( owner, pObj )
	local codec = owner.codec:upper()
	if codec == "G711" or codec == "G.711" then
		pObj:InternalSetInt(8000)	--G.711 only support 8KHz sampling
	--TODO: others
	end
end

local function getChannels( owner, pObj )
	local codec = owner.codec:upper()
	if codec == "G711" or codec == "G.711" then
		pObj:InternalSetInt(1)	--G.711 only support mono
	--TODO: others
	end
end

local function encoderConfigChanged( obj )
	local aEngine = require "audio_engine"
	local channel = obj:Name()
	aEngine.UpdateEncoderChannel( tonumber(channel) )
end

local function getEnable( owner, pObj )
	local channelId = tonumber( owner:Name() )
	if channelId == 1 then	--Always enable for encoding channel1
		pObj:InternalSetInt( 1 )
	end
end

---------

AudioEngine_Template = OBJECT({
	maxEncoderChannels = { type="integer", value=1, writeEnable = false },
	
	encoders = ARRAY(
		{ 1 },
		
		OBJECT({
			enable = { type="integer", value=0, onRead = getEnable },
			
			source = OBJECT({
				type={ type="string", value="ALSA" },
				device = { type="string", value="default" },
				resample = { type="string", value="fastest" }
			}),
		
			encoder = OBJECT({
				codec={ type="string", value="AAC" },
				sampling = { type="integer", value=48000, onRead = getSampling },
				channels = { type="integer", value=2, onRead = getChannels },
				sampleSize = { type="integer", value=256 },	--For G711 only, otherwise should auto select
				bitrate = { type="integer", value=64000 },
				
				aac = OBJECT({
					type = { type="string", value="AAC-LC" },
					format = { type="string", value="ADTS", noPersist=true, onRead = function(owner,pObj)
						pObj:InternalSetString("ADTS")	--Now forced ADTS
					end
					}
				}),
			
				g711 = OBJECT({
					law = { type="string", value="ULAW" },
				}) -- G.711 configure
			}) --Encoder configure
		}, encoderConfigChanged) --Encoders item
	) --Encoders array
})



