local _M = {}

---------------------------------------------------
-- KPulling CoAF bus service operations
---------------------------------------------------

local kpull_svc_methods = {}
kpull_svc_methods.__index = kpull_svc_methods

function kpull_svc_methods:get_ServiceType()
	return "KMP/PULLING_SERVER"
end

function kpull_svc_methods:get_Enabled()
	local thisConfig = _G.streamer.stream[self.cfgId].Kmp_pullingServer
	if not thisConfig then
		return false
	else
		return _G.streamer.stream[self.cfgId].enabled ~= 0 and thisConfig.enabled ~= 0	--Return global enabled status.
	end
end

function kpull_svc_methods:get_ServiceUri()
	local thisConfig = _G.streamer.stream[self.cfgId].Kmp_pullingServer
	if not thisConfig then
		return ""
	elseif not self.service then
		return "offline"
	else
		return "kpull://%HOST%/" .. self.service.channel
	end
end

function kpull_svc_methods:Enable(en)
	local thisConfig = _G.streamer.stream[self.cfgId].Kmp_pullingServer
	if not thisConfig then
		return false
	else
		CONFIGS.BeginUpdate()
		thisConfig.enabled = en and 1 or 0
		CONFIGS.Submit()
		return thisConfig.enabled ~= 0 and _G.streamer.stream[self.cfgId].enabled ~= 0
	end
end

function kpull_svc_methods:Update()
	local streams = require "streams"
	streams.UpdateKmpPullingServer( _G.streamer.stream[self.cfgId].enabled ~= 0, self.streamId )
end

function kpull_svc_methods:GetStatus()
	return 1, { ["stream.status"] = self.service and "online" or "offline" }
end

------------------------------

function _M.ServiceMethods()
	return kpull_svc_methods
end

return _M
