local _M = {}
---------------------------------------------------
-- Omnistream CoAF bus pushing service operations
---------------------------------------------------

local omni_push_svc_methods = {}
omni_push_svc_methods.__index = omni_push_svc_methods

function omni_push_svc_methods:get_ServiceType()
	return "OMNI/PUSH"
end

function omni_push_svc_methods:ServiceName()
	return "OMNI udp pushing of stream " .. self.appId .. "-" .. self.streamId
end

function omni_push_svc_methods:get_Enabled()
	local thisConfig = _G.streamer.stream[self.cfgId].Dynamic_services[self.dynamicIndex].Omnistream
	if not thisConfig then
		return false
	else
		return _G.streamer.stream[self.cfgId].enabled ~= 0 and thisConfig.enabled ~= 0
	end
end

function omni_push_svc_methods:get_ServiceUri()
	local thisConfig = _G.streamer.stream[self.cfgId].Dynamic_services[self.dynamicIndex].Omnistream
	--or _G.streamer.stream[self.cfgId].enabled == 0 or thisConfig.enabled == 0 
	if not thisConfig then
		return "offline"
	elseif self.streamer then
		return "omni://" .. thisConfig.address .. "?video=" .. thisConfig.video_port .. "&audio=" .. thisConfig.audio_port
	else
		--return "offline"
		return "omni://" .. thisConfig.address .. "?video=" .. thisConfig.video_port .. "&audio=" .. thisConfig.audio_port
	end
end

function omni_push_svc_methods:Enable(en)
	local thisConfig = _G.streamer.stream[self.cfgId].Dynamic_services[self.dynamicIndex].Omnistream
	if not thisConfig then
		return false
	else
		CONFIGS.BeginUpdate()
		thisConfig.enabled = en and 1 or 0
		CONFIGS.Submit()
		return thisConfig.enabled ~= 0 and _G.streamer.stream[self.cfgId].enabled ~= 0
	end
end

