local _M = {}

---------------------------------------------------
-- RTSP CoAF bus service operations
---------------------------------------------------

local rtsp_svc_methods = {}
rtsp_svc_methods.__index = rtsp_svc_methods

function rtsp_svc_methods:get_ServiceType()
	return "RTSP/SERVER"
end

function rtsp_svc_methods:get_Enabled()
	local thisConfig = _G.streamer.stream[self.cfgId].Rtsp_server
	if not thisConfig then
		return false
	else
		return _G.streamer.stream[self.cfgId].enabled ~= 0	--Return global enabled status.
	end
end

function rtsp_svc_methods:get_ServiceUri()
	local thisConfig = _G.streamer.stream[self.cfgId].Rtsp_server
	if not thisConfig then
		return ""
	elseif not self.service then
		return "offline"
	else
		return "rtsp://%HOST%:" .. thisConfig.port .. "/" .. self.service.session
	end
end

function rtsp_svc_methods:Enable(en)
	return false
end

function rtsp_svc_methods:Update()
	local streams = require "streams"
	streams.UpdateRtspServer( true, self.streamId )
end

function rtsp_svc_methods:GetStatus()
	return 1, { ["stream.status"] = self.service and "online" or "offline" }
end

------------------------------

function _M.ServiceMethods()
	return rtsp_svc_methods
end

return _M
