--The Streaming Server service

local SERVER_SVC = {
	Identifier = "StreamServer",
	FriendlyName = "Stream server service",
	Version = "1.0",
	ConfigPrefix = "streamer_global",
}

function SERVER_SVC:Activate()
end

function SERVER_SVC:Start()
end

function SERVER_SVC:Stop()
end

function SERVER_SVC:Reset()
	os.exit(0)
end

function SERVER_SVC:Terminate()
	os.exit(0)
end

function SERVER_SVC:Control(action,params)
	if action == "activate" then
		self:Activate()
		return 0, {}
	elseif action == "start" then
		self:Start()
		return 0, {}
	elseif action == "stop" then
		self:Stop()
		return 0, {}
	elseif action == "Reset" then
		self:Reset()
		return 0, {}
	elseif action == "terminate" then
		self:Terminate()
		return 0, {}
	elseif action == "hold-amba-iav" then
		--TODO: Quickly hold ambarella IAV device.
		return 0, {}
	else
		return -1, {}
	end
end

function SERVER_SVC:Set(params)
	return 0	--Nothing set.
end

function SERVER_SVC:SetEnv(params)
	return 0	--Nothing set.
end

function SERVER_SVC:Get(inParams)
	return 0, inParams
end

function SERVER_SVC:GetEnv(inParams)
	return 0, inParams
end

function SERVER_SVC:RestoreDefault()
	return 0
end

function SERVER_SVC:LoadConfigureFile(filename)
	CONFIGS.BeginUpdate()
	local r = pcall( dofile, filename )
	CONFIGS.Submit()
	if r then
		return 1
	else
		return 0
	end
end

function SERVER_SVC:GetApplications()
	return 1, { ["DefaultApp"] = "Default streaming application" }
end

function SERVER_SVC:GetApplicationByID(appId)
	return "/DefaultApp"
end

function SERVER_SVC:ActiveNDI( skip )
	local config = _G.streamer.stream[0].NDI_server
	if config then
		_G.streamer.stream[0].NDI_server.enabled = tonumber(skip) == 1
	end
end

function SERVER_SVC:PushControl()
	local streams = require "streams"
	streams.PushControl()
	return true
end

function SERVER_SVC:GetPushStatus()
	local streams = require "streams"
	return streams.GetPushStatus()
end

----------------------------------------------------

local _M = {}

function _M.Init( cosvc )
	if cosvc then
		cosvc:ExposeObject( "/", SERVER_SVC )
	end

	print( "StreamServer service online." )
end

---- Each second checking

function _M.Check()
end

return _M

