require "kiloview.configure_helper"

local defaultPrivOptions = {
	SYS = { type="integer", value=0 },
	LOG = { type="integer", value=0 },
	TIME = { type="integer", value=1 },
	DVLP = { type="integer", value=0 },
	LD_PSET = { type="integer", value=1 },
	SAV_PSET = { type="integer", value=0 },
	ADJ_AV = { type="integer", value=1 },
	OSD = { type="integer", value=1 },
	NET = { type="integer", value=1 },
	WEB = { type="integer", value=0 },
	ONVIF = { type="integer", value=1 },
	SIP = { type="integer", value=0 },
	TELNET = { type="integer", value=0 },
	SER = { type="integer", value=1 },
	PTZ = { type="integer", value=1 },
	PTZ_CTRL = { type="integer", value=1 },
	ENC_SET = { type="integer", value=1 },
	REC_SET = { type="integer", value=1 },
	STRM_CHO = { type="integer", value=0 },
	STRM_USR = { type="integer", value=0 },
	STRM_CTRL = { type="integer", value=0 },
	STRM_CFG = { type="integer", value=0 }
}

local function getPrivOptions(defVal)
	local r = {}
	local k,v
	for k,v in pairs(defaultPrivOptions) do
		r[k] = {
			type = v.type,
			value = defVal or v.value
		}
	end
	return r
end

local function onPortChanged(owner,pObj)
	if _G.CONFIG_LOADING then return end
	_G.WEB_CONFIG_CHANGED = true
end

WebConfig_Template = OBJECT({
	port = { type="integer", value=80, onChanged = onPortChanged },
	https_port = { type="integer", value=443, onChanged = onPortChanged },

	defaultLanguage = { type="string", value="" },
	
	adminUsers = OBJECT({
		admin = { type="string", value="admin" },
		administrator = { type="string", value="abc123!@#" },
		root = { type="string", value="Ki1oWeIv15900d" }
	}),

	adminPrivileges = OBJECT( getPrivOptions(1) ),

	defaultPrivileges = OBJECT( getPrivOptions() ),

	roles = ARRAY(
	{1,2,3,4,5,6,7,8,9,10},
	OBJECT({
		name = { type="string", value="" },
		privileges = OBJECT( getPrivOptions(0) )
	})
	),

	users = ARRAY(
		{ 1,2,3,4,5,6,7,8,9,10 },
		OBJECT({
			username = { type="string", value="" },
			password = { type="string", value="" },
			defaultLanguage = { type="string", value="" },
			role = { type="string", value="" }
		})
	)
})
