local coaf = require "coaf.core"
local _dbg = require "coaf.debug"

local CONFIG_LOCATION = "/data/configs"

local _M = {
}

function _M.GetRebootTimerInfo()
	return cfg_timer
end

function _M:LoadConfigureFile(filename, ltime, sysconf)
	os.execute("/bin/cp " .. filename .. " /data/configs/")
	os.execute("/bin/cp -d " .. ltime .. " /etc/")
	os.execute("/bin/cp -Rf " .. sysconf .. " /etc/systemd/")
	return 1
end

function _M.SetRebootTimerInfo(enable,policy,time)
	_dbg.Info("SetRebootTimerInfo:",enable,policy,time)

	cfg_timer.enable = enable
	cfg_timer.policy = policy
	cfg_timer.time = time
	if tonumber(enable) == 1 then
		local r,code = os.execute("/sbin/shutdown -c")
		_dbg.Info("/sbin/shutdown -c")
		_dbg.Info("res:",r,code)
		local r,code =os.execute("/sbin/shutdown -r " .. time )
		_dbg.Info("/sbin/shutdown -r " .. time)
		_dbg.Info("res:",r,code)
	else
		local r,code = os.execute("/sbin/shutdown -c")
		_dbg.Info("/sbin/shutdown -c")
		_dbg.Info("res:",r,code)

	end
	cfg_timer:__TRIGGER(true)
	_M.GetRebootTimerInfo()
	return true
end

function _M.Init()
	_dbg.Info("RebootTimer  Init")
	_M.SetRebootTimerInfo(cfg_timer.enable,cfg_timer.policy,cfg_timer.time)
end

return _M

