local DC = require "supertable.declare"
local CONF = require "supertable.core"

----------------------------
local _M = {
	config_location = "/data/configs",
	config_file = "timer.conf"
}

----------------------------

local timer_template = 
	DC.OBJ({
		enable = DC.INT(0),
		policy = DC.STR("day"),
		time = DC.STR("00:00")
	
}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

----------------------------

local failDefault = {
	enable=0,policy=day,time="00:00"
}

-------------------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, timer_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_location .. "/" .. _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure 
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


