------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=WWAN}: 连接到一个WWan Connection
##ARGUMENTS{POST}: 
  @@DeviceObject: 可选参数。如果指定，则为网络接口的ObjectID（参见 ^^REF{getNetInterface.lua}）；如果没有指定，则为默认的WWan接口
  @@Object{*}: 要连接WWan Connection的Object名称（通过 ^^REF{listWWanConnection.lua} 可以获得）

##RETURNS{DEFAULT}: 
]]

local WWAN = require "M_WWanSet"
local cgilua = require "cgilua"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Object then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid request arguments"
}
]])
	return
end

local objectId = args.DeviceObject
if not objectId or objectId == "" or objectId == "/" then
	local device = WWAN.GetDefaultWWan()
	if not device then
		cgilua.put([[
	{
		"Result":500,
		"Status":"FAIL: Fault to get WWan device"
	}
	]])
		return
	end
	objectId = device.Object
end

-- local r,msg = WWAN.ConnectConnection( objectId, args.Object )
local r,msg = WWAN.ConnectConnection( objectId, args.Object ) --设备名 连接id

cgilua.put([[
{
	"Result":]] .. (r and "200" or "400") .. [[,
	"Status":"]] .. (msg or "OK") .. [["
}
]])

