------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=WWAN}: 忘记（删除）一个WWAN连接
##ARGUMENTS{GET,POST}: 
  @@Object{*}: 要删除WWan连接的Object名称（通过 ^^REF{listWWanConnection.lua} 可以获得）

##RETURNS{DEFAULT}: 
]]

local WWAN = require "M_WWanSet"
local cgilua = require "cgilua"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Object then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid request arguments"
}
]])
	return
end

local r,msg = WWAN.DeleteConnection( args.Object )

cgilua.put([[
{
	"Result":]] .. (r and "200" or "400") .. [[,
	"Status":"]] .. (msg or "OK") .. [["
}
]])


