------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=TIME_LOCATION}: 获取设备的位置/时区配置

##ARGUMENTS: 
  无

##RETURNS: 
	++Data{OBJ}:
		**Timezone{STR}: 时区，格式如 Asia/Shanghai
	~~
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )
local _x,timedateinfo = rpc.Call("SYS_STATUS.GetTimeDateInfo")
local tz
if not timedateinfo then
	tz = "UTC"
else
	tz = timedateinfo["zone"]
end

cgilua.put([[
{
	"Result":200,
	"Status":"OK",
	"Data":{
		"Timezone":"]] .. tz .. [["
	}
}
]])
