------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------
local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local stream
local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Stream or args.Stream == "" then
	cgilua.put([[
	{
		"Result":400,
		"Status":"ERROR: Invalid stream"
	}
]])
	return
end

stream = args.Stream

local streamId = 0
if stream == "sub" then
	streamId = 1
end

local argPrefix = "streamer.stream[" .. streamId .. "].Scrambling"
local r,cc,rets = rpc.Call( "BUS.Get", { [ argPrefix .. ".enabled"] = 0, [ argPrefix .. ".seed"] = "0", [argPrefix .. ".depth"] = "" } )
if not r or not rets then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to get scrambling setting"
}
]])
	return
end

--[[
local seed = rets[ argPrefix .. ".seed" ] or "00000000"
local depth = rets[ argPrefix .. ".depth" ] or "00000000"
local prefix = seed:sub(1,2)
if prefix == "0x" or prefix == "0X" then
	seed = seed:sub(3)
end

prefix = depth:sub(1,2)
if prefix == "0x" or prefix == "0X" then
	depth = depth:sub(3)
end

seed = "00000000" .. seed
depth = "00000000" .. depth

seed = seed:sub( #seed - 7 )
depth = depth:sub( #depth - 7 )
]]
local seed = rets[ argPrefix .. ".seed" ] or "00000000"
local prefix = seed:sub(1,2)
if prefix ~= "0x" and prefix ~= "0X" then
	seed = "0x" .. seed
end

cgilua.put([[
{
	"Result":200,
	"Status":"OK",
	"Data":{
		"Enable":]] .. rets[argPrefix .. ".enabled"] .. [[,
		"Seed":"]] .. seed .. [["
	}
}
]])

