------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=BASIC}: 获得Web (HTTP)服务端口
##ARGUMENTS{GET,POST}:

##RETURNS: 
  ++Data{OBJ}:
  **ServicePort{INT}: HTTP服务端口
  ~~
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local gets = {["webConfig.port"] = 80 }

local r, cc, gets = rpc.Call( "BUS.Get", gets )

if not r or not gets then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to get arguments"
}
]])
else
	cgilua.put([[
{
	"Result":200,
	"Status":"OK",
	"Data":{
		"ServicePort":]] .. (gets[ "webConfig.port" ] or 80) .. [[
	}
}
]])

end

