------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=AV-SOURCE}: 设置模拟音频环出
>> 控制模拟音频从In到Out的线路环出。当打开环出功能时，从In输入的模拟音频将直接从Out口输出。

##ARGUMENTS{GET,POST}: 
	@@Enable{INT}: 1表示打开环出功能，0表示关闭环出功能。

##RETURNS{DEFAULT}: 
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Enable or args.Enable == "" then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid request arguments"
}
]])
	return
end

local en = tonumber(args.Enable)

local r,x
r,x = rpc.Call( "BUS.Set", { ["avio.audio.line_bypass"] = en or 0 } )

cgilua.put([[
{
	"Result":]] .. (r and "200" or "400") .. [[,
	"Status":"]] .. (x and "OK" or "ERROR: Fail to set audio bypass") .. [["
}
]])

