local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.REMOTE_ADDR or args.REMOTE_ADDR == "" then
	cgilua.put([[
	{
		"Result":400,
		"Status":"Invalid arguments"
	}
]])
	return
end

local _x,done,msg = rpc.Call( "SYS_STATUS.SetIrConnectionParams", args )
if not _x or not done then
	cgilua.put([[
	{
		"Result":400,
		"Status":"Fail to set IR connection parameters"
	}
]])
	return
end

cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])
