------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=TIME_LOCATION}: 设置设备的位置/时区配置

##ARGUMENTS{GET,POST}: 
  @@Timezone{*}: 时区名称。格式如 Asia/Shanghai

##RETURNS{DEFAULT}: 
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Timezone or args.Timezone == "" then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid arguments"
}
]])
	return
end

rpc.Call( "SYS_STATUS.SetTimezone", args.Timezone )

cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])
