------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=ENCODING}: 设置当前编码/Streaming模式

>> KILOVIEW编码产品支持 "主码流 + 子码流" 或 "主码流" 模式。本API可以设置当前的编码/Streaming模式。

##ARGUMENTS{GET,POST}: 
    @@Mode{*}: 码流(Streaming)模式
    %%main: 仅主码流
    %%main+sub: 主码流+子码流
    ~~

##RETURNS{DEFAULT}: 

]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or not args.Mode or args.Mode == "" then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid arguments"
}
]])
	return
end

local r,x = rpc.Call( "BUS.Set", { ["encoder.encode_mode"] = (args.Mode == "main+sub" and "main+sub" or "main") } )
if not r or not x then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to set streaming mode"
}
]])
	return
end

cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])

