------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=WIFI}: 设置Wi-Fi的全局配置选项
##ARGUMENTS{GET,POST}:
	@@ScanPlan{STR}: WiFi的国家/区域/规范选项
		%%0x00: FCC 
		%%0x01: IC 
		%%0x02: ETSI 
		%%0x03: SPAIN 
		%%0x04: FRANCE 
		%%0x05: MKK 
		%%0x06: MKK1 
		%%0x07: ISRAEL 
		%%0x08: TELEC 
		%%0x09: GLOBAL_DOAMIN 
		%%0x0a: WORLD_WIDE_13 
		%%0x0b: TAIWAN 
		%%0x0c: CHINA 
		%%0x0d: SINGAPORE_INDIA_MEXICO (ETSI:Singapore, India. FCC:Mexico => WW)
		%%0x0e: KOREA 
		%%0x0f: TURKEY 
		%%0x10: JAPAN 
		%%0x11: FCC_NO_DFS 
		%%0x12: JAPAN_NO_DFS 
		%%0x13: WORLD_WIDE_5G 
		%%0x14: TAIWAN_NO_DFS 
		%%0x15: ETSI_NO_DFS 
		%%0x16: KOREA_NO_DFS 
		%%0x17: JAPAN_NO_DFS 
		%%0x18: PAKISTAN_NO_DFS 
		%%0x19: TAIWAN2_NO_DFS 
		%%0x1f: WORLD_WIDE_ONLY_5G
	~~

##RETURNS: 
]]

local cgilua = require "cgilua"
local rpc = require "kiloview.ringRpc"

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype( "application/json; charset=utf-8" )

local args = require("M_Request").VerifyAndGetArgs()
if not args or type(args.ScanPlan) ~= "string" or args.ScanPlan == "" then
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Invalid arguments"
}
]])
	return
end

local sets = { ["hostapm.wifiSpecConfig.country_code"] = string.lower(args.ScanPlan) }
local r,x = rpc.Call( "BUS.Set", sets )
if r and x then
	cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])

else
	cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to set arguments"
}
]])

end

