------------------------------------------------------
-- KILOVIEW Device HTTP Api, v1.0
-- Copyright (c) 2016, KILOVIEW Electronics.
------------------------------------------------------

--[[

##ABSTRACT{G=RECORD}: 停止指定码流的录像

##ARGUMENTS{GET,POST}:
    @@Stream{STR,*}:
        指定要停止录像的码流。
        %%main: 主码流
		%%sub: 子码流
		%%main+sub: 主码流+子码流
	~~

##RETURNS{DEFAULT}: 
]]
local cgilua = require 'cgilua'
local rpc = require 'kiloview.ringRpc'

local SAPI = SAPI or cgilua.SAPI
SAPI.Response.contenttype('application/json; charset=utf-8')

local stream
local args = require('M_Request').VerifyAndGetArgs()
if not args or not args.Stream or args.Stream == '' then
    cgilua.put([[
	{
		"Result":400,
		"Status":"ERROR: Invalid stream"
	}
]])
    return
end

stream = args.Stream
local streamId = 0

local sets
if stream == 'main+sub' then
    local argPrefix_main = 'record_m.stream[0]'
    local argPrefix_sub = 'record_m.stream[1]'
    sets = {[argPrefix_main .. '.start'] = 0, [argPrefix_sub .. '.start'] = 0}
else
    if stream == 'sub' then
        streamId = 1
    end
    local argPrefix = 'record_m.stream[' .. streamId .. ']'
    sets = {[argPrefix .. '.start'] = 0}
end

local r, x = rpc.Call('BUS.Set', sets)
if not r or not x then
    cgilua.put([[
{
	"Result":400,
	"Status":"ERROR: Fail to stop recording"
}
]])
else
    cgilua.put([[
{
	"Result":200,
	"Status":"OK"
}
]])
end
