local cgilua = require "cgilua"
local cookies = require "cgilua.cookies"
local rpc = require "kiloview.ringRpc"
local _M = {}

function _M.Check(nopost_flag)
	local lang
	if cgilua.QUERY and cgilua.QUERY.language then
		lang = cgilua.QUERY.language
	end

	if not lang then
		if not nopost_flag and cgilua.POST and cgilua.POST.language then
			lang = cgilua.POST.language
		end
		
		if not lang then
			lang = cookies.get("PAGE_LANGUAGE")
		end
	end
		
	local r
	if not lang then	--Not get, so using the default language.
		r, lang = rpc.Call( "SERVER.DefaultLanguage" )
	end	--Bug fixed.
	
	r, lang = rpc.Call( "SERVER.CheckValidLanguage", lang )

	if r and lang then
		return lang
	else
		return "en"	--Default, en
	end
end

return _M

