--Controller of correct VGA formats
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

---------- AJAX Call -----------
local function SelectVGAFormat( format_code, modeline )
	if not format_code then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_FORMAT_CODE .. [["}]]
	end

	local r = _M.MasterCall( "BUS.VGASpecialCtrl", "set", "SPEC-FORMAT", { format_code = format_code, modeline = _M.utils.url_decode(modeline) } )
	if r then 
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_SEL_FORMAT_DONE .. [[", "Refresh": 1 }]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_SEL_FORMAT_FAIL .. [["}]]
	end
end

local function AdjustVGA( format_code, shiftX, shiftY, phase )
	if not format_code then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_FORMAT_CODE .. [["}]]
	end

	local r = _M.MasterCall( "BUS.VGASpecialCtrl", "set", "PICTURE-ADJUSTMENT", { format_code = format_code, shiftX = shiftX or 0, shiftY = shiftY or 0, phase = phase } )
	if r then 
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_ADJUST_DONE .. [[", "Refresh": 1 }]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_ADJUST_FAIL .. [["}]]
	end
end


--------------------------------
_M.AjaxExport  ("SelectVGAFormat", SelectVGAFormat, "json") 
_M.AjaxExport  ("AdjustVGA", AdjustVGA, "json") 
--------------------------------

return _M
