--Controller of datetime
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

---------- AJAX Call -----------

local function SetLocation( zone )
	if not zone then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end
	_M.MasterCall( "SYS_STATUS.SetTimezone", zone )
	return  [[ {"Result":200, "Msg":"]] .. _M.langs.SET_LOCATION_DONE .. [[","Refresh":1}]]
end

local function SetTime( method, args )
	if not method or not args then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	local r,done = _M.MasterCall( "SYS_STATUS.SetTime", method, args )
	if not r or not done then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	else
		return  [[ {"Result":200, "Msg":"]] .. _M.langs.SET_DONE .. [[","Refresh":1}]]
	end
end

--------------------------------
_M.AjaxExport("SetLocation", SetLocation, "json" )
_M.AjaxExport("SetTime", SetTime, "json") 
--------------------------------

return _M
