--Controller of encoder_set
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

---------- AJAX Call -----------

local function get_key(tpe, idr)
	return "encoder.stream[" .. idr .. "].video.qp_" .. tpe
end

local function SaveSet( args )
	if not args or type(args) ~= "table" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	local min = args[get_key("min", 0)] or args[get_key("min", 1)] or args[get_key("min", 2)]
	local max = args[get_key("max", 0)] or args[get_key("max", 1)] or args[get_key("max", 2)]
	if min and max and (tonumber(min) > tonumber(max)) then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	local r,x = _M.MasterCall( "BUS.Set", args )
	if r and x then 
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_SAVE_DONE .. [["}]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_SAVE_FAIL .. [["}]]
	end
end

--------------------------------
_M.AjaxExport ("SaveSet", SaveSet, "json") 
--------------------------------

return _M

