--Controller of hls_set
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

---------- AJAX Call -----------

local function SaveSet( args )
	if not args or type(args) ~= "table" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end


	local params = {}
	for i = 0, 1 do
		for j = 0, 8 do
			params["streamer.stream[" .. i .. "].Dynamic_services[" .. j .. "].HLS.enabled"] = 0
			params["streamer.stream[" .. i .. "].Dynamic_services[" .. j .. "].HLS.session"] = ""
			params["streamer.stream[" .. i .. "].Dynamic_services[" .. j .. "].serviceType"] = ""
		end
	end

	local is_ok, skip, data = _M.MasterCall("BUS.Get", params)
	if not is_ok or not skip or skip < 0 then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_SAVE_FAIL .. [["}]]
	end

	local set_session
	for k, v in pairs(args) do
		if k:match("session") then
			set_session = v
		end
	end

	if not set_session then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS .. [["}]]
	end

	for i = 0, 1 do
		for j = 0, 8 do
			local tpe = data["streamer.stream[" .. i .. "].Dynamic_services[" .. j .. "].serviceType"]
			local session = data["streamer.stream[" .. i .. "].Dynamic_services[" .. j .. "].HLS.session"]
			if tpe == "HLS" and not args["streamer.stream[" .. i .. "].Dynamic_services[" .. j .. "].HLS.session"] and session == set_session then
				return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_POST_ARGS_USED .. [["}]]
			end
		end
	end

	local r,x = _M.MasterCall( "BUS.Set", args )
	if r and x then 
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_SAVE_DONE .. [["}]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_SAVE_FAIL .. [["}]]
	end
end

--------------------------------
_M.AjaxExport ("SaveSet", SaveSet, "json") 
--------------------------------

return _M

