--Controller of jianbo_set
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

---------- AJAX Call -----------

local function SaveSet( args )
	if not args or type(args) ~= "table" then
		return [[ {"Result":400, "Msg":"Invalid arguments"}]]
    end
    
    if not args.addr or not args.addr:match("%d+%.%d+%.%d+%.%d+") then
        return [[ {"Result":400, "Msg":"Invalid REMOTE ADDR"}]]
    end

    if not args.port or not tonumber(args.port) or tonumber(args.port) < 1024 then
        return [[ {"Result":400, "Msg":"Invalid REMOTE PORT"}]]
    end

	local _x,done,msg = _M.MasterCall( "ARP.SetNetLink", args.addr, args.port, args.authcode, args.timeout )
	if not _x then
		return [[ {"Result":400, "Msg":"]] .. (done or "ERROR") .. [["} ]]
	elseif not done then
		return [[ {"Result":400, "Msg":"]] .. (msg or "ERROR") .. [["} ]]
	else
		return [[ {"Result":200, "Msg":"Updated."}]]
	end
end

--------------------------------
_M.AjaxExport ("SaveSet", SaveSet, "json") 
--------------------------------

return _M

