--Controller of userman
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

------------
local function AddNAS( id, name, type, host, volumn, options )
	if not id or id == "" or not host or host == "" or not volumn or volumn == "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_ARGUMENT .. [["}]]
	end

	local cid = string.gsub(id, "%w", "")
	if cid ~= "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_ARGUMENT .. [["}]]
	end

	local r,x,msg = _M.MasterCall( "BUS.AddNAS", id, name, type, host, volumn, options )
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_ADD_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":400, "Msg":"]] .. (msg or "Unknown").. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_ADD_FAIL .. [["}]]
	end
end

local function RemoveNAS(id)
	if not id or id == "" then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERRMSG_INVALID_NAS_ID .. [["}]]
	end
	local r,x,msg = _M.MasterCall( "BUS.RemoveNAS", id )
	if r then 
		if x then
			return [[ {"Result":200, "Msg":"]] .. _M.langs.MSG_REMOVE_DONE .. [[", "Refresh":1 }]]
		else
			return [[ {"Result":400, "Msg":"]] .. (msg or "Unknown").. [[" }]]
		end
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MSG_REMOVE_FAIL .. [["}]]
	end
end
-------------- AJAX CALL ----------------
_M.AjaxExport ("AddNAS", AddNAS, "json") 
_M.AjaxExport ("RemoveNAS", RemoveNAS, "json" )
---------------------------------------------

function _M.GetNAS()
	local r,gets = _M.MasterCall( "BUS.GetNASList")
	if r and gets then
		return gets
	else
		return nil
	end
end

return _M

