--Controller of osd
local _M = require( "controller.generic" )()
local cgilua = require "cgilua"

-------------------------------------------

local function checkVera(text)
	if type(text) ~= "string" then
		return true
	end

	text = text:gsub("%p", "")
	text = text:gsub("%s", "")
	text = text:gsub("%w", "")
	return text ~= ""
end

local function checkPicCount(streamId)
	local params = { 
		["osd.stream[" .. streamId .. "].items[0].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[1].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[2].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[3].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[4].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[5].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[6].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[7].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[8].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[9].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[10].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[11].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[12].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[13].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[14].osd_type"] = "none",
		["osd.stream[" .. streamId .. "].items[15].osd_type"] = "none"
	}

	local is_ok, skip, result = _M.MasterCall( "BUS.Get", params )
	if not is_ok or not skip or not result then
		return false, false
	end

	local count = 0
	for _, v in pairs(result) do
		if v == "image" then
			count = count + 1
		end
	end

	if count >= 3 then
		return false, true
	end

	return true
end

local function AddOverlay( streamId, osd_type, show, pos, x, y, font, size, bold, outline, text, img, font_color, outline_color, line_space, format )
	if not streamId then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS .. [["} ]]
	else
		streamId = tonumber(streamId)
		if streamId < 0 or streamId > 2 then
			return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS .. [["} ]]
		end
	end

	if font ~= "song" and checkVera(text) then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS_CN .. [["} ]]
	end

	if osd_type == "image" then
		local is_ok, skip = checkPicCount(streamId)
		if not is_ok then
			if skip then
				return [[ {"Result":400, "Msg":"]] .. _M.langs.LIMIT_PIC_COUNT .. [["} ]]
			else
				return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_FAIL_GETPARAMS .. [["} ]]
			end
		end
	end
	
	local params = { ["osd.stream[" .. streamId .. "].items[0].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[1].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[2].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[3].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[4].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[5].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[6].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[7].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[8].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[9].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[10].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[11].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[12].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[13].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[14].osd_type"] = "none",
					["osd.stream[" .. streamId .. "].items[15].osd_type"] = "none"
	}
	
	local r, n
	r,n,params = _M.MasterCall( "BUS.Get", params )
	if not r or not n or not params then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_FAIL_GETPARAMS .. [["} ]]
	end
	
	for n=0, 15 do
		r = "osd.stream[" .. streamId .. "].items[" .. n .. "].osd_type"
		if params[r] == 'none' then
			r = "osd.stream[" .. streamId .. "].items[" .. n .. "]."
			local setArgs = {
				[ r .. "osd_type" ] = osd_type or "text",
				[ r .. "show_when" ] = show or "always",
				[ r .. "position" ] = pos or "left-top",
				[ r .. "x" ] = x or 0,
				[ r .. "y" ] = y or 0,
				[ r .. "font" ] = font or "default",
				[ r .. "size" ] = size or 1,
				[ r .. "bold" ] = bold or 0,
				[ r .. "outline" ] = outline or 2,
				[ r .. "text" ] = text or "",
				[ r .. "image_id" ] = img or "",
				[ r .. "font_color" ] = font_color or 1,
				[ r .. "outline_color" ] = outline_color or 0,
				[ r .. "line_space" ] = line_space or "x0.5",
				[ r .. "format" ] = format or ""

			}
			local x = _M.MasterCall( "BUS.Set", setArgs )
			if x then
				return [[ {"Result":200, "Msg":"]] .. _M.langs.ADD_OVERLAY_DONE .. [[", "Refresh":1} ]]
			else
				return [[ {"Result":400, "Msg":"]] .. _M.langs.ADD_OVERLAY_FAIL .. [["} ]]
			end
		end
	end
	
	return [[ {"Result":400, "Msg":"]] .. _M.langs.MAX_LIMIT .. [["} ]]
end

-------------------------------------------

local function ModifyOverlay( streamId, areaId, osd_type, show, pos, x, y, font, size, bold, outline, text, img, font_color, outline_color, line_space, format )
	if not streamId or not areaId then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS .. [["} ]]
	else
		streamId = tonumber(streamId)
		areaId = tonumber(areaId)
		if streamId < 0 or streamId > 2 or areaId < 0 or areaId > 15 then
			return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS .. [["} ]]
		end
	end

	if osd_type == "image" then
		local is_ok, skip = checkPicCount(streamId)
		if not is_ok then
			if skip then
				return [[ {"Result":400, "Msg":"]] .. _M.langs.LIMIT_PIC_COUNT .. [["} ]]
			else
				return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_FAIL_GETPARAMS .. [["} ]]
			end
		end
	end

	if font ~= "song" and checkVera(text) then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS_CN .. [["} ]]
	end
	
	local r = "osd.stream[" .. streamId .. "].items[" .. areaId .. "]."
	local setArgs = {
		[ r .. "osd_type" ] = osd_type,
		[ r .. "show_when" ] = show,
		[ r .. "position" ] = pos,
		[ r .. "x" ] = x,
		[ r .. "y" ] = y,
		[ r .. "font" ] = font,
		[ r .. "size" ] = size,
		[ r .. "bold" ] = bold,
		[ r .. "outline" ] = outline,
		[ r .. "text" ] = text,
		[ r .. "image_id" ] = img,
		[ r .. "font_color" ] = font_color or 1,
		[ r .. "outline_color" ] = outline_color or 0,
		[ r .. "line_space" ] = line_space or "x0.5",
		[ r .. "format" ] = format or ""
	}
	
	local x = _M.MasterCall( "BUS.Set", setArgs )
	if x then
		return [[ {"Result":200, "Msg":"]] .. _M.langs.MODI_OVERLAY_DONE .. [[", "Refresh":1} ]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.MODI_OVERLAY_FAIL .. [["} ]]
	end
	
end

-------------------------------------------

local function RemoveOverlay( streamId, areaId )
	if not streamId or not areaId then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS .. [["} ]]
	else
		streamId = tonumber(streamId)
		areaId = tonumber(areaId)
		if streamId < 0 or streamId > 2 or areaId < 0 or areaId > 15 then
			return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS .. [["} ]]
		end
	end
	
	local r = "osd.stream[" .. streamId .. "].items[" .. areaId .. "]."
	local setArgs = {
		[ r .. "osd_type" ] = "none"
	}
	
	local x = _M.MasterCall( "BUS.Set", setArgs )
	if x then
		return [[ {"Result":200, "Msg":"]] .. _M.langs.REMOVE_OVERLAY_DONE .. [[", "Refresh":1} ]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.REMOVE_OVERLAY_FAIL .. [["} ]]
	end
end

-------------------------------------------
local function SetStream( streamId, en, norotate )
	if not streamId then
		return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS .. [["} ]]
	else
		streamId = tonumber(streamId)
		if streamId < 0 or streamId > 2 then
			return [[ {"Result":400, "Msg":"]] .. _M.langs.ERROR_INVALID_ARGUMENTS .. [["} ]]
		end
	end
	
	local r = "osd.stream[" .. streamId .. "]."
	local setArgs = {
		[ r .. "enabled" ] = en,
		[ r .. "norotate" ] = norotate
	}
	
	local x = _M.MasterCall( "BUS.Set", setArgs )
	if x then
		return [[ {"Result":200, "Msg":"]] .. _M.langs.SET_DONE .. [[", "Refresh":1} ]]
	else
		return [[ {"Result":400, "Msg":"]] .. _M.langs.SET_FAIL .. [["} ]]
	end	
end
-------------------------------------------

_M.AjaxExport ("AddOverlay", AddOverlay, "json") 
_M.AjaxExport ("ModifyOverlay", ModifyOverlay, "json" )
_M.AjaxExport ("RemoveOverlay", RemoveOverlay, "json" )
_M.AjaxExport ("SetStream", SetStream, "json" )

function _M.GetIMAGE()
	local r,gets = _M.MasterCall( "BUS.GetIMAGEList")
	if r and gets then
		return gets
	else
		return nil
	end
end

return _M
