﻿/*
 * All the global routines.
 * Copyright (C) KILOVIEW Electronic CO., LTD.
 * http://www.kiloview.com/
 */

function getCookie( _name )  
{ 
    var search = _name + "=";
    if(document.cookie.length > 0) 
    { 
        offset = document.cookie.indexOf(search);
        if(offset != -1) 
        { 
            offset += search.length;
            end = document.cookie.indexOf(";", offset);

            if( end == -1 ) end = document.cookie.length;
            return unescape( document.cookie.substring(offset, end) );
        } 
        else
        { return ""; }
    } 
    return "";
} 

function show_message( _msg )
{
	var d = dialog({
		title: global_language == "cn" ? "提示消息":"Message",
		content: _msg,
		okValue: global_language == "cn" ? "确定":"OK",
		ok: function() {}
	});
	
	d.showModal();
}

function showSuccess(_target)
{
	var d = dialog({
		title: global_language == "cn" ? "提示消息":"Message",
		content: OPERATE_SUCCESS,
		okValue: global_language == "cn" ? "确定":"OK",
		ok: function() {}
	}).width(300);
	
	d.showModal();
}

var G_QsRequest = new QsAjaxRequestHandle();  

var browserName=navigator.appName; 

if (browserName=="Netscape") { 
	function closeme() { 
		window.open('','_parent',''); 
		window.close(); 
		var d = dialog({
			title: global_language == "cn" ? "警告！" : "Warning!",
			content: global_language == "cn" ? "当前浏览器不支持自动关闭窗口，请手动关闭浏览器窗口以退出登录！" : 'Sorry, your browser looks not support auto window closing. <br/> <br/>To exit this console, please close your browser window manually.',
			okValue: global_language == "cn" ? "确定":"OK",
			ok: function() {}
		});
	
		d.showModal();
	} 
}else{ 
	if (browserName=="Microsoft Internet Explorer") { 
		function closeme() { 
		    window.opener = "test"; 
		    window.close(); 
		} 
	} 
} 

function QsAjaxErrorHint( k_restState )
{
	if( k_restState=="400" )
	{
		show_message( AJAX_MSG_400 );
	}
	else if( k_restState=="401" )
	{
		show_message( AJAX_MSG_401 );
	}
	else if( k_restState=="403"  )
	{
		show_message( AJAX_MSG_403 );
	}
	else if( k_restState=="404" ) 
	{
		 show_message( AJAX_MSG_404 );
	}
	else if( k_restState=="405" )                                                
	{
		 show_message( AJAX_MSG_405 );
	}
	else
	{
		 show_message( AJAX_MSG_OTHER_ERROR + k_restState );
	}
}
 
function  QsAjaxRequestHandle() 
{
    var m_Me             = this;  
    var m_SendUriMap     = [];         
    this.m_AjaxTimeOut   = 30000; 

    this.Init = function(){
    };

	this.block =function()
	{
	};

	this.unblock =function()
	{
	};

    this.SubmitForm = function( _form , _fnSuccessEvent , _fnFailEvent , _fnBeforeSubmit )
    {   
		var k_unblock =false;

		var options = { 
			async		:	true,   
			dataType	:	"json",
			timeout		:	m_Me.m_AjaxTimeOut,
			cache		:	false,

			success : function( _data2 ) {
				m_Me.unblock(); k_unblock= true;
				if( _data2 && (typeof _data2 == "object") && _data2.Result ) {
					if( (_data2.Result >= 200) && (_data2.Result < 300) ) {
						if( _fnSuccessEvent ){
							try{ _fnSuccessEvent( _data2.Body ); } catch(err) {}    
						}
					}
					else if( _data2.Result >= 400 ){
						if( _fnFailEvent ){
							_fnFailEvent( _data2.Result, _data2.k_msg );    
						}
						else{
							QsAjaxErrorHint( _data2.Result );     
						}
					}
				}
			}, //End of success callback function

			error : function( XMLHttpRequest, textStatus, errorThrown ){
				m_Me.unblock();
				var k_msg= HTTP_SUBMIT_ERROR;
				if( textStatus ) {
					if( textStatus =="error" ) {
						k_msg = HTTP_SUBMIT_REQUEST_ERROR;
					}
				}
				show_message(k_msg );
			}, //End of error callback function

			beforeSubmit : function( formData, jqForm, options ){
				var k_rst = true;
				if( _fnBeforeSubmit ) {
					k_rst = _fnBeforeSubmit( formData, jqForm, options );
				}

				if( k_rst ){
					m_Me.block(); 
				}

				return k_rst;
			}, //End of beforeSubmit callback function

			complete : function() {
				if( !k_unblock )m_Me.unblock();
			} //End of complete callback function

		}; //End of options

		$( _form ).ajaxForm(options);   //Add options to form. 

    }; //End of this.SubmitForm

	this.GetValue= function( _url,  _data,   _fnSuccessEvent, _fnFailEvent  ) 
	{
		var k_unblock =false;
		$.ajax({ 
			url		:	_url ,  
			async	:	false,
			dataType:	"json",   
			timeout	:	m_Me.m_AjaxTimeOut,
			cache	:	false, 
			data	:	_data,

			success : function( _data2 ){
				m_Me.unblock(); k_unblock =true;
				if( _data2 && (typeof _data2 == "object") &&  _data2.Result ) {
					if( (_data2.Result >= 200 ) && ( _data2.Result < 300 ) ) {
						if( _fnSuccessEvent ){
							try{ _fnSuccessEvent( _data2.Body ); } catch(err) {}    
						}
					}
					else if( _data2.Result >= 400 ){
						if( _fnFailEvent ){
							_fnFailEvent( _data2.Result, _data2.k_msg );    
						}
					}
				}                           
			},	//End of success callback function
            
			error : function( XMLHttpRequest, textStatus, errorThrown ) {
				m_Me.unblock();
			}, //End of error callback function

			beforeSend : function(){
				m_Me.block(); 
			}, //End of beforeSend callback function

			complete : function(){
				if( !k_unblock ) m_Me.unblock();
			} //End of complete callback function
		});  // $.ajax(
	};

	this.GetValue2 = function( _url,  _data,   _fnSuccessEvent, _fnFailEvent ) 
	{
		var k_unblock =false;
		$.ajax({ 
			url		:	_url,  
			async	:	false,
			dataType:	"json",   
			type	:	'POST',
			timeout	:	m_Me.m_AjaxTimeOut,
			cache	:	false, 
			data	:	_data,

			success : function( _data2 ){
				 m_Me.unblock(); k_unblock =true;
				 if( _data2 && (typeof _data2 == "object") &&  _data2.Result  ) {
					if(  (_data2.Result >= 200 ) && ( _data2.Result < 300 ) ) {
						if( _fnSuccessEvent ){
							try{ _fnSuccessEvent( _data2.Body ); }catch(err){}    
						}
					}
					else if( _data2.Result >= 400 ){
						if( _fnFailEvent ){
							_fnFailEvent( _data2.Result, _data2.k_msg );    
						}
					}
				}                           
			},	//End of success callback function

			error : function( XMLHttpRequest, textStatus, errorThrown ) {
				m_Me.unblock();
			},

			beforeSend : function(){
				m_Me.block(); 
			},

			complete:function(){
				if( !k_unblock ) m_Me.unblock();
			}
		});  // $.ajax(        
	};

  	this.ActionRequest= function( _url,  _data,   _fnSuccessEvent, _fnFailEvent  ) 
	{
		var k_unblock =false;
		$.ajax({ 
			url		:	_url ,  
			async	:	true, 
			dataType:	"json",   
			timeout	:	m_Me.m_AjaxTimeOut,
			cache	:	false, 
			data	:	_data,

			success : function( _data2 ){

				if( _data2 && (typeof _data2 == "object") &&  _data2.Result ) {
					if( (_data2.Result >= 200 ) && ( _data2.Result < 300 ) ) {
						if( _fnSuccessEvent ){
							try{ _fnSuccessEvent( _data2.Body ); } catch(err) {}    
						}
					}
					else if( _data2.Result >= 400 ){
						if( _fnFailEvent ){
							_fnFailEvent( _data2.Result, _data2.k_msg );    
						}
					}
				}                           
			},	//End of success callback function
            
			error : function( XMLHttpRequest, textStatus, errorThrown ) {
			}, //End of error callback function

			beforeSend : function(){
			}, //End of beforeSend callback function

			complete : function(){
			} //End of complete callback function
		});  // $.ajax(
	};

	this.SetValue= function( _url,  _data, _fnSuccessEvent, _fnFailEvent ) 
	{
		var k_unblock =false;
		$.ajax({ 
			url		:	_url ,  
			async	:	false,
			dataType:	"json",   
			timeout	:	m_Me.m_AjaxTimeOut,
			cache	:	false, 
			data	:	_data,

			success : function( _data2 )
			{
				m_Me.unblock(); k_unblock =true;
				if( _data2 && (typeof _data2 == "object") &&  _data2.Result  ){
					if( (_data2.Result >= 200 ) && ( _data2.Result < 300 ) ){
						if( _fnSuccessEvent ){
							 try{ _fnSuccessEvent( _data2.Body ); } catch(err) {}    
						}
						if( _data2.Result == "206") {
							show_message( AJAX_MSG_2XX ); 
						}  
					}
					else if( _data2.Result >= 400 ){
						if( _fnFailEvent ){
							_fnFailEvent( _data2.Result, _data2.k_msg );    
						}
						else {
							QsAjaxErrorHint( _data2.Result )  ;     
						}
					}
				}
			},

			error : function( XMLHttpRequest, textStatus, errorThrown ) 
			{
				m_Me.unblock();
				var k_msg= HTTP_SUBMIT_ERROR ;
				if( textStatus ) {
					if( textStatus =="error" ){
						k_msg = HTTP_SUBMIT_REQUEST_ERROR;
					}
				}
				show_message(k_msg );
			},

			beforeSend : function()  
			{
				m_Me.block(); 
			},

			complete:function()
			{
				if( ! k_unblock ) m_Me.unblock();
			}
		});  // $.ajax(        
	};
}

