#!/usr/bin/env lua

require "features"	--What device current configured?

if not _G.DEVICE_TYPE then
	_G.DEVICE_TYPE = "UNKNOWN"
end

local did, hwChk = pcall( require, "kiloview." .. _G.DEVICE_TYPE .. ".hardwareCheck" )
if not did or type(hwChk) ~= "table" then
	os.exit(1)
end

local dtsTables 
did, dtsTables = pcall( dofile, "/etc/hardware_dts.d/map.cfg" )
if not did or type(dtsTables) ~= "table" then
	os.exit(1)
end

local dtsTable = dtsTables[_G.DEVICE_TYPE] or dtsTables["default"]
if type(dtsTable) ~= "table" then
	os.exit(1)
end

hwChk.Check()
if not hwChk.hardwareVersionSwCode then
	os.exit(1)
end

local i
local dtsFile
for i=1, #dtsTable do
	if dtsTable[i].versionCode and dtsTable[i].file and dtsTable[i].versionCode >= hwChk.hardwareVersionSwCode then
		dtsFile = "/etc/hardware_dts.d/" .. dtsTable[i].file
		break
	end
end

if dtsFile then
	local file = io.open( "/etc/current_hardware_dts.conf", "r" )
	local current_dts_file
	if file then
		while true do
			current_dts_file = file:read("l")
			if not current_dts_file then
				break
			else
				current_dts_file = current_dts_file:match("^%s*(.-)%s*$")
				if current_dts_file ~= "" then
					break
				end
			end
		end

		file:close()
	end
	if current_dts_file ~= dtsFile then
		print( dtsFile )
		os.exit(0)
	else
		os.exit(1)
	end
else
	os.exit(1)
end


