local CFG = require "supertable.core"
local DC = require "supertable.declare"

local _M = {
	env_file = "/data/configs/co_env.conf"
}

local environment_decl = DC.SET( DC.OBJ {
	--Any fields allowed.
} ) : __changed( function(conf)
	conf:TAB_SAVE()
end )

function _M.Load(file)
	local gen_set = CFG.Create( {}, environment_decl )
	gen_set:TAB_STORAGE( "file", { file = file or _M.env_file } )
	gen_set:TAB_LOAD()
	gen_set:TAB_RESET_CHANGE()
	return gen_set
end

return _M

