local DC = require "supertable.declare"
local CONF = require "supertable.core"

----------------------------
local _M = {
	config_location = "/data/configs",
	config_file = "nas.conf"
}

----------------------------

local nas_template = DC.SET(
	DC.OBJ({
		name = DC.STR(""),
		type = DC.STR("none"),
		host = DC.STR(""),
		volumn = DC.STR(""),
		options = DC.STR("")
	})
) : __changed( function(conf)
	conf:TAB_SAVE()
end)

----------------------------

local failDefault = {
} 
-------------------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, nas_template)
	conf:TAB_STORAGE( "file", { file =  _M.config_location .. "/" .. _M.config_file } )
	local _, r = conf:TAB_LOAD()
	if not r then --Try load a fail-default configure 
		conf:TAB_BIND(failDefault)
	end
	conf:TAB_RESET_CHANGE()
	return conf
end

-------------------------------------------------------

return _M


