--NOTE everyone:
--This is just a demo script to start discovery functions
--on coserver startup. You can add this file name into:
--
-- RUN = {...} 
--
-- arguments in 'coserver.conf' to make it auto run.
--
--*CAREFUL* that this is *NOT* the default option. JUST A
--DEMO ONLY! You can change the script to suite your actual 
--application.
--
--*DONT FORGET* that you can call the discovery functions
--by CoAF RPC. That's your correct way! That is:
--
--location: "local"
--service:  "_CO_DAEMON.coserver"
--object:   "/discovery"
--

local discovery = require "coserver.discovery"
local coserver = require "coserver.core"

--If the global config file disabled discovery functions,
--just ignore it.
if not coserver.configs.ENABLE_DISCOVERY then
	return
end

--TODO: Set your link token here, or don't set it to let it
--      generate a random token.
discovery.SetLinkToken( "w8erD@1B" )

--TODO: Declare your publish options in this table:
local publish_options = {
	name = "KILOVIEW",
	group = "encoder.gseries",

	--NOTE: 'link_token' is allowed to set the link token
	--      like 'SetLinkToken'
	
	--link_token = "w8erD@1B"
	
	--TODO: Any other options you can pass.
}

--TODO: Start the publish, to let the world know you!
discovery.PublishGlobal(publish_options)

--NOTE: Call this twice is a SUGGESTION! mDNS mechanism will
--      cache your host informations in other machines, they
--      will not update until cache timeout! Try publish 
--      twice will notify all other machines that I'm online
--      again.
discovery.PublishGlobal(publish_options)

--TODO: Then start the discovery service, to discover the
--      world!
--      Parameter is optional. This is a match pattern to 
--      set group filter. nil or '*' means match any groups,
--      or a Lua string pattern to match group names. 
--      e.g. 'encoder%..*' means match any group name start
--      with 'encoder.'

discovery.StartDiscovery('*')

