local client = require "coaf.client"
local _dbg = require "coaf.debug"

local _M = {}

local function GetCoAFProxy( objPath, service, loc, timeout )
	local proxy                
	local cli                  
	cli = client.New( service, loc, nil, timeout or 3 ) --3 seconds timeout.
	if not cli then
		_dbg.Error( "CO", "Fail to create connection to service: " .. (loc or "local") .. "/" .. (service or "nil") )
		return nil
	end
	proxy = cli:CreateProxy(objPath, true) --Exclusive
	if not proxy then          
		_dbg.Error( "CO", "Fail to create object proxy for '" .. (objPath or "unknown") .. "'" ) 
		return nil             
	end
	return proxy               
end


function _M.Reboot()
	os.execute( "/sbin/wdog enable" )	--Open the watch-dog to control monitor rebooting.
	os.execute( "/sbin/reboot" )
end

function _M.Reset()
	local streamerProxy = GetCoAFProxy( "/", "streamer", "local", 1 )
	local codecProxy = GetCoAFProxy( "/Codec", "codec", "local", 1 )
	
	if streamerProxy then
		streamerProxy:Reset()
		streamerProxy:Destroy()
	end
	
	if codecProxy then
		codecProxy:Reset()
		codecProxy:Destroy()
	end
end

return _M
