#!/bin/sh
#TODO: Some checks.
export PATH=/bin:/sbin:/usr/bin:/usr/sbin

LOCPATH=$1
if [ "$LOCPATH" = "" ]; then
	LOCPATH=/tmp/.fw_upgrade
fi

#Drop core dump files.
rm -Rf /var/lib/systemd/coredump/*

#The font storage patch:
/bin/mkdir -p /data/fonts
for item in `/bin/ls /usr/share/fonts/*.ttf 2>/dev/null`; do
	if ! /usr/bin/test -L "$item"; then
		/bin/mv -f "$item" /data/fonts/
		/bin/ln -sf /data/fonts/$(basename "$item") "$item"
	fi
done

mkdir -p /data/update

if [ -f "$LOCPATH/patch.tar.gz" -a -f "$LOCPATH/upgrade.sh" ]; then
	cp -Rf "$LOCPATH/patch.tar.gz" /data/update/patch.tar.gz
	cp -Rf "$LOCPATH/upgrade.sh" /data/update/upgrade.sh
	if [ -f "$LOCPATH/touch.files" ]; then
		cp -Rf "$LOCPATH/touch.files" /data/update/touch.files
	fi
	chmod +x /data/update/upgrade.sh
	sync && sync #Write-back.
	exit 0
else
	exit 1 #No upgrading firmware
fi

exit 1

